#ifndef WORLD_H
#define WORLD_H

#include "common/block/BlockRegistry.h"

class World final {
public:
    World(const BlockRegistry& blockRegistry);
    void setBlock(int x, int y, int z, const Block& block);
    const Block& getBlock(int x, int y, int z) const;
    
    static constexpr int WORLD_SIZE = 32;

private:
    static constexpr int BITMASK = WORLD_SIZE - 1;

    const BlockRegistry& blockRegistry;
    BlockId blocks[WORLD_SIZE][WORLD_SIZE][WORLD_SIZE];
};

#endif